//-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-
//@ȃ{Jn[hCgtB^io_SelfOverlay_Blurj v0.4
//@@@by iuser/5145841j
//-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-

//-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-
//@[U[p[^

//@ڂ̃TvO
#define SAMP_NUM  7

//@邳␳[hi1FS̓IɈÂA0FÂ͕␳Ȃj
#define BRIGHTNESS_MODE  1

//@ڂ͈(TvO͌Œ̂߁A傫ƎȂo܂)
//@@ݒ 0.001953125i=2^-9j
float Extent
<
   string UIName = "Extent";
   string UIWidget = "Slider";
   bool UIVisible =  true;
   float UIMin = 0.00;
   float UIMax = 0.01;
> = float( 0.001953125 );

//@I[o[CC[̖x␳i 0`1F0Ő^A1ŕ␳Ȃj
//@@ݒ 0.8
float4 Correction
<
   string UIName = "Correction";
   string UIWidget = "Slider";
   bool UIVisible =  true;
   float UIMin = 0.0;
   float UIMax = 1.0;
> = float( 0.8 );

float Script : STANDARDSGLOBAL <
    string ScriptOutput = "color";
    string ScriptClass = "scene";
    string ScriptOrder = "postprocess";
> = 0.8;

//@}eAF
float4 MaterialDiffuse : DIFFUSE  < string Object = "Geometry"; >;
static float alpha1 = MaterialDiffuse.a;

float brightness0 : CONTROLOBJECT < string name = "(self)"; string item = "Si"; >;
static float brightness = brightness0 * 0.1;

float scaling0 : CONTROLOBJECT < string name = "(self)"; string item = "X"; >;
static float scaling = scaling0 + 1.0;

//@XN[TCY
float2 ViewportSize : VIEWPORTPIXELSIZE;

static float2 ViewportOffset = (float2(0.5,0.5)/ViewportSize);

static float2 SampStep = (float2(Extent,Extent)/ViewportSize*ViewportSize.y) * scaling;

//@_O^[Qbg̃NAl
float4 ClearColor = {1,1,1,1};
float ClearDepth  = 1.0;

//@[xobt@
texture2D DepthBuffer : RENDERDEPTHSTENCILTARGET <
    float2 ViewPortRatio = {1.0,1.0};
    string Format = "D24S8";
>;

//@IWi̕`挋ʂL^邽߂̃_[^[Qbg
texture2D ScnMap : RENDERCOLORTARGET <
    float2 ViewPortRatio = {1.0,1.0};
    int MipLevels = 1;
    string Format = "A8R8G8B8" ;
>;
sampler2D ScnSamp = sampler_state {
    texture = <ScnMap>;
    MinFilter = LINEAR;
    MagFilter = LINEAR;
    MipFilter = NONE;
    AddressU  = CLAMP;
    AddressV = CLAMP;
};

//@X̂ڂʂL^邽߂̃_[^[Qbg
texture2D ScnMap2 : RENDERCOLORTARGET <
    float2 ViewPortRatio = {1.0,1.0};
    int MipLevels = 1;
    string Format = "A8R8G8B8" ;
>;
sampler2D ScnSamp2 = sampler_state {
    texture = <ScnMap2>;
    MinFilter = LINEAR;
    MagFilter = LINEAR;
    MipFilter = NONE;
    AddressU  = CLAMP;
    AddressV = CLAMP;
};

//-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-
// ʒ_VF[_
struct VS_OUTPUT {
    float4 Pos            : POSITION;
    float2 Tex            : TEXCOORD0;
};

VS_OUTPUT VS_passDraw( float4 Pos : POSITION, float4 Tex : TEXCOORD0 ) {
    VS_OUTPUT Out = (VS_OUTPUT)0; 
    
    Out.Pos = Pos;
    Out.Tex = Tex + ViewportOffset;
    
    return Out;
}

//-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-
// Xڂ

float4 PS_passX( float2 Tex: TEXCOORD0 ) : COLOR {   
    float4 sum = 0;
    float e, n = 0;
    
    [unroll]for(int i = -SAMP_NUM; i <= SAMP_NUM; i++){
        e = exp(-pow(i / (SAMP_NUM / 2.0), 2) / 2); //Kz
        sum += tex2D( ScnSamp, Tex + float2(SampStep.x * i, 0) ) * e;
        n += e;
    }
    
    return sum / n;
}

//-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-
// Yڂ + 

float4 PS_passY(float2 Tex: TEXCOORD0) : COLOR
{   
	float Tonemap;		//@vZbgǂݍ񂾕␳J[ꎞi[
    float4 Color = 1.0, sum = 0;
    float4 ColorOrg = tex2D( ScnSamp, Tex );
    
    float e, n = 0;
    
    [unroll]for(int i = -SAMP_NUM; i <= SAMP_NUM; i++){
        float2 stex = Tex + float2(0, SampStep.y * i);
        e = exp(-pow(i / (SAMP_NUM / 2.0), 2) / 2); //Kz
        sum += tex2D( ScnSamp2, stex ) * e;
        n += e;
    }
    
    //@{JI[o[CC[̖x
#if BRIGHTNESS_MODE
    Color.rgb = sum.rgb / n * Correction*brightness;
#else
    Color.rgb = sum.rgb / n;
    Color.r = Color.r > 0.5 ? ( (Color.r - 0.5) * Correction*brightness ) + 0.5 : Color.r;
    Color.g = Color.g > 0.5 ? ( (Color.g - 0.5) * Correction*brightness ) + 0.5 : Color.g;
    Color.b = Color.b > 0.5 ? ( (Color.b - 0.5) * Correction*brightness ) + 0.5 : Color.b;
#endif
    
	[unroll]for(int i=0; i < 3; i++)
	{
		if(Color[i] < 0.5)
		{
			Color[i] = ColorOrg[i] * Color[i] * 2;
		} else{
			Color[i] = 1 - 2 * ( 1 - ColorOrg[i] ) * ( 1 - Color[i] );

		}
	}

	//@ANZT̕sxɃIWiƍ
    return lerp(ColorOrg, Color, alpha1);
}

//-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-

technique Diffusion <
    string Script = 
        
        "RenderColorTarget0=ScnMap;"
        "RenderDepthStencilTarget=DepthBuffer;"
        "ClearSetColor=ClearColor;"
        "ClearSetDepth=ClearDepth;"
        "Clear=Color;"
        "Clear=Depth;"
        "ScriptExternal=Color;"
        
        "RenderColorTarget0=ScnMap2;"
        "RenderDepthStencilTarget=DepthBuffer;"
        "ClearSetColor=ClearColor;"
        "ClearSetDepth=ClearDepth;"
        "Clear=Color;"
        "Clear=Depth;"
        "Pass=Gaussian_X;"
        
        "RenderColorTarget0=;"
        "RenderDepthStencilTarget=;"
        "ClearSetColor=ClearColor;"
        "ClearSetDepth=ClearDepth;"
        "Clear=Color;"
        "Clear=Depth;"
        "Pass=Gaussian_Y;"
    ;
    
> {
    pass Gaussian_X < string Script= "Draw=Buffer;"; > {
        AlphaBlendEnable = FALSE;
        VertexShader = compile vs_2_0 VS_passDraw();
        PixelShader  = compile ps_2_0 PS_passX();
    }
    pass Gaussian_Y < string Script= "Draw=Buffer;"; > {
        AlphaBlendEnable = FALSE;
        VertexShader = compile vs_3_0 VS_passDraw();
        PixelShader  = compile ps_3_0 PS_passY();
    }
}
////////////////////////////////////////////////////////////////////////////////////////////////
